<template>
  <div class="home">
 <table id="test-table">
      <thead>
        <tr>
          <th>Nom</th>
          <th>Prenom</th>
          <th>Mail</th>
          <th>Reseau</th>
          <th>Admin</th>
          <th>Superadmin</th>
          <th>Action</th>
        </tr>
      </thead>
      <tfoot></tfoot>
      <tbody>
				<tr>
          <td><label for=""><input type="text" name="" id="" placeholder="Nom" required v-model="newUser.nom"/></label></td>
          <td><label for=""><input type="text" name="" id="" placeholder="Prenom" required v-model="newUser.prenom"/></label></td>
          <td><label for=""><input type="text" name="" id="" placeholder="Mail" required  v-model="newUser.mail"/></label></td>
          <td><label for="">
            <select placeholder="Reseau" v-model="newUser.reseau" >
            <option value="CA">CA</option>
            <option value="CCI">CCI</option>
            <option value="CMA">CMA</option>
            </select>
          </label></td>
          <td><label for=""><input type="checkbox" name="" id="" placeholder="Admin" checked="false" :disabled="!($store.getters.isSuperAdmin)"  v-model="newUser.admin"/></label></td>
          <td><label for=""><input type="checkbox" name="" id="" placeholder="SuperAdmin" checked="false" :disabled="!($store.getters.isSuperAdmin)"  v-model="newUser.superadmin"/></label></td>
          <td>
           <button @click="addUser"><i class="fas fa-user-plus"></i></button>
					</td>
        </tr>
      <tr v-for="user in users" v-bind:key="user.email">
        <td>{{ user.nom }}</td><td>{{ user.prenom }}</td><td>{{ user.mail }}</td><td>{{ user.reseau }}</td>
        <td><input type="checkbox" :checked="user.admin" disabled></td>
        <td><input type="checkbox" :checked="user.admin" disabled></td>
        <td><button class="button"><i class="fa fa-edit" @click="editUser(user)"></i></button>
							<button class="button"><i class="fa fa-trash" @click="deleteUser(user)"></i></button></td>
      </tr>
      </tbody>
    </table>
  </div>
  
</template>

<script>
import { computed, ref } from "vue";
import store from "@/store";

export default {
  name: "Home",
  setup() {
    const newUser = ref({
      nom: "",
      prenom: "",
      mail: "",
      reseau: "",
      departement: "",
      admin: false,
      superadmin: false,
    });
    const users = computed(() => {
      return store.getters.getUsers;
    });
    fetchUsers();

    function fetchUsers() {
      store.dispatch("setUsers");
    }
    function addUser() {
      if (
        newUser.value.nom.length !== 0 &&
        newUser.value.prenom.length !== 0 &&
        newUser.value.mail.length !== 0
      )
        store.dispatch("addUser", newUser.value);
    }
    function deleteUser(user) {
      store.dispatch("removeUser", user);
    }
    function editUser(user) {
      alert("à implémenter pour modifier " + user.nom + "!");
    }

    return { users, newUser, fetchUsers, addUser, deleteUser, editUser };
  },
};
</script>
<style scoped>
table {
  width: 100%;
}
td form {
  margin: 0;
  padding: 0;
}
td form button.button {
  padding: 0.25em;
  margin: 0.25em;
  background: none;
  color: blue;
}
td form button.button:hover {
  background: none;
  color: steelblue;
}
</style>